#include <stdio.h>
#include <proto.h>

#include "common.h"
#include "error.h"
#include "dlink.h"

/************************************************************************\
*
* File I/O module for 'tagorg'.
*
* $Copyright: (C) 1997 by Gran Gustafsson $ 
*
\************************************************************************/


static char tname[256];

/************************************************************************\
*
* Load taglist from file.
*
\************************************************************************/
void LoadTagList(char *name,DLink *lhd)
{
	FILE *in;
	ubyte len;
	TList *tl;
	
	if((in=fopen(name,"rb")))
	{
		fgets(tname,256,in);
		if(strcmp(tname,"TAGS\n")!=0)
			Error(ERR_FATAL,"File is not a tagfile");
		while(!feof(in))
		{
			if(!fgets(tname,256,in))
				continue;
			len=strlen(tname);
			if(tname[len-1]=='\n')
			{
				tname[len-1]=0;
				len--;
			}
			if(!(tl=(TList *)malloc(sizeof(TList)+len)))
				Error(ERR_FATAL,"No memory for tags");
			strcpy(tl->name,tname);
			dl_AddTail(lhd,&tl->lnk);
		}
		fclose(in);
	}
}

/************************************************************************\
*
* Save taglist to file.
*
\************************************************************************/
void SaveTagList(char *name,DLink *lhd)
{
	FILE *out;
	TList *tl;
	
	if((out=fopen(name,"wb")))
	{
		fprintf(out,"TAGS\n");
		while((tl=(TList *)dl_RemHead(lhd)))
		{
			fprintf(out,"%s\n",tl->name);
			free(tl);
		}
		fclose(out);
	}
	else
		Error(ERR_FATAL,"Unable to write file");
}
